#include <qdebug.h>
#include "matrixmult.h"
#include "ui_matrixmult.h"

MatrixMult::MatrixMult(QWidget *parent)
    : QMainWindow(parent), ui(new Ui::MatrixMult)
{
    ui->setupUi(this);
    connect(ui->actionQuit, SIGNAL(triggered()),this,SLOT(fileQuit()));

    connect(ui->a11, SIGNAL(valueChanged(double)),this,SLOT(calculate()));
    connect(ui->a12, SIGNAL(valueChanged(double)),this,SLOT(calculate()));
    connect(ui->a21, SIGNAL(valueChanged(double)),this,SLOT(calculate()));
    connect(ui->a22, SIGNAL(valueChanged(double)),this,SLOT(calculate()));
    connect(ui->b11, SIGNAL(valueChanged(double)),this,SLOT(calculate()));
    connect(ui->b12, SIGNAL(valueChanged(double)),this,SLOT(calculate()));
    connect(ui->b21, SIGNAL(valueChanged(double)),this,SLOT(calculate()));
    connect(ui->b22, SIGNAL(valueChanged(double)),this,SLOT(calculate()));
    calculate();
}

MatrixMult::~MatrixMult()
{
    delete ui;
}

void MatrixMult::fileQuit()
{
    QCoreApplication::quit();
}

void MatrixMult::calculate()
{
//
// calculate matrix mutiplication
//
    double a11,a12,a21,a22;
    double b11,b12,b21,b22;
    double r11,r12,r21,r22;
    double i11,i12,i21,i22;

    a11 = ui->a11->value();
    a12 = ui->a12->value();
    a21 = ui->a21->value();
    a22 = ui->a22->value();
//    qDebug() << a11 << " " << a12 << " " << a21 << " "<< a22 << endl;

    b11 = ui->b11->value();
    b12 = ui->b12->value();
    b21 = ui->b21->value();
    b22 = ui->b22->value();

//    qDebug() << b11 << " " << b12 << " " << b21 << " "<< b22 << endl;

    r11 = a11*b11+a12*b21;
    r12 = a11*b12+a12*b22;
    r21 = a21*b11+a22*b21;
    r22 = a21*b12+a22*b22;

    QString r11String,r12String,r21String,r22String;
    r11String.sprintf("%f",r11);
    r12String.sprintf("%f",r12);
    r21String.sprintf("%f",r21);
    r22String.sprintf("%f",r22);

    ui->r11->setText(r11String);
    ui->r12->setText(r12String);
    ui->r21->setText(r21String);
    ui->r22->setText(r22String);

//
// calculate the inverse matrix
//

    double det = r11*r22-r12*r21;
    if (det == 0.0)
        return;
    i11 = r22/det;
    i12 = -r12/det;
    i21 = -r21/det;
    i22 = r11/det;

    QString i11String,i12String,i21String,i22String;

    i11String.sprintf("%f",i11);
    i12String.sprintf("%f",i12);
    i21String.sprintf("%f",i21);
    i22String.sprintf("%f",i22);

    ui->i11->setText(i11String);
    ui->i12->setText(i12String);
    ui->i21->setText(i21String);
    ui->i22->setText(i22String);
}
